package Libconf::GUI::Gtk2::CheckButton;

use ugtk2 qw(:helpers :wrappers :create);
use Libconf::GUI::Gtk2::Widget;

# multiple inheritance, yaaaaaaaaaaaaaaa
our @ISA = qw(Gtk2::CheckButton Libconf::GUI::Gtk2::Widget);

#constructor
#@widget_options is optional
sub new {
    my ($class, $default, $ref_value, $data_mapping, @widget_options) = @_;
    my $self = $class->SUPER::new(@widget_options);
    $self->{default_value} = $default;
    $self->{data_mapping} = $data_mapping;
    $self->{ref_value} = $ref_value;
    bless $self, $class;
    gtksignal_connect($self, toggled => sub {
                          my $widget = shift;
                          my $value = $widget->get_active();
                          defined $data_mapping and $value = $data_mapping->($value);
                          $self->set_value($value);
                          print " getvalue : -- " . $self->get_value() . "\n";
                      });
    return $self;
}

sub set_value {
    my $self = shift;
    $self->set_active($self->SUPER::set_value(@_));
}

1;
